					;    _____         __
					;   /  _  \_______|  | ______  ______
					;  /  /_\  \_  __ \  |/ /  _ \/  ___/
					; /    |    \  | \/    <  <_> )___ \
					; \____|__  /__|  |__|_ \____/____  >
					;         \/           \/         \/
					; Keyboard library.
					; Grim/Arkos^Semilanceata

					; *************************
					; *** Keyboard scanning ***
					; *************************

; **************************** QWERTY Map *************************************
;Bits/ 	7 		6 		5 		4 		3 		2 		1 		0 
;Line
;&40		F. 		ENTER 	F3 		F6 		F9 		CURDOWN 	CURRIGHT 	CURUP 
;&41		F0 		F2 		F1 		F5 		F8 		F7 		COPY 	CURLEFT 
;&42		CONTROL 	\ 		SHIFT 	F4 		] 		RETURN 	[ 		CLR 
;&43		. 		/ 		: 	 	; 		P 		@ 		- 		^ 
;&44		, 		M 		K 		L 		I 		O 		9 		0 
;&45		SPACE 	N 		J 		H 		Y 		U 		7 		8 
;&46		V 		B 		F 		G 		T 		R 		5 		6 
;&47		X 		C 		D 		S 		W 		E 		3 		4 
;&48		Z 		CAPSLOCK 	A 		TAB 		Q 		ESC 		2 		1 
;&49		DEL 		- 		- 		- 		- 		- 		- 		-

					; common keycheck shortcuts
kbd_key_esc:
					ld a,&48
					call kbd_read_row
					bit 2,a
					ret
kbd_key_space:
					ld a,&45
					call kbd_read_row
					bit 7,a
					ret

					; bulky keyboard-rowscan
kbd_read_row:
					ld bc,&f40e
					out (c),c
					ld bc,&f6c0
					out (c),c
					dw &71ED
					ld bc,&f792
					out (c),c
					dec b
					out (c),a
					ld a,&f4
					in a,(&FF)
					dw &71ED
					ld bc,&f782
					out (c),c
					ret
