.line_empty
	ds 61,0
	ret			;3nops
	
.line_prev_first
	ld E,#55		;0	2	blue
	out (C),A		;2	4 	pen 1
	out (C),E		;6	4
	ld HL,#025E		;10	3	pen 2 yellow
	out (C),H		;13	4
	out (C),L		;17	4
					;21
	
	ds 64-24,0
	ret				;3
	
.line_logo_color1
	ld E,#55		;0 2 bright blue
	out (C),C		;2 4 pen 3
	out (C),E		;6 4 color
	ds 64-13,0		;10
	ret
	
.line_logo_color2
	ld E,#53		;0 2 bright cyan
	out (C),C		;2 4 pen 3
	out (C),E		;6 4 color
	ds 64-13,0		;10
	ret
	
.line_logo_color3
	ld E,#4B		;0 2 white
	out (C),C		;2 4 pen 3
	out (C),E		;6 4 color
	ds 64-13,0		;10
	ret	
	
.line_logo_color4
	ld E,#4C		;0 2 bright red
	out (C),C		;2 4 pen 3
	out (C),E		;6 4 color
	ds 64-13,0		;10
	ret	
	
.line_logo_color4_last	;prepare to next change
	ld E,#4C		;0 2 bright red
	out (C),C		;2 4 pen 3
	out (C),E		;6 4 color
	
	ld DE,#025E		;10 3 for pen 2 selection and default color (yellow)
	ld HL,#584D		;13 3 colors for pen 3
	
	ld A,#4A		;16 2 color 2 for pen 2 (replaced pen 1 in A as it will not be used)
	
	out (C),D		;18 4 setup pen 2
	
	ds 61-22,0		;22
	
	ret
	
.line_logo_color5	;pen 2 is supposed to be selected !
	out (C),E		;0  4 pen 2 to yellow
	out (C),C		;4 	4 selected pen 3		(we are on border)
	out (C),H		;8 	4 pen 3 to purple 
	nop				;12 1
	out (C),L		;13 4 pen 3 to bright purple

					;17
	out (C),D		;17 4 pen 2
	out (C),A		;21 4 pen 2 to bright yellow	
	
	ds 61-25,0
	
	ret
	
.line_logo_color6	;pen 2 is supposed to be selected !
	out (C),C		;0 	4 selected pen 3		(we are on border)
	out (C),H		;4 	4 pen 3 to purple 
	ds 5,0			;8 	5
	out (C),L		;13 4 pen 3 to bright purple

					;17
	
	ds 61-17,0
	
	ret
	
.line_logo_color6_last	;pen 2 is supposed to be selected !
	out (C),C		;0 	4 selected pen 3		(we are on border)
	out (C),H		;4 	4 pen 3 to purple 
	ds 5,0			;8 	5
	out (C),L		;13 4 pen 3 to bright purple

	ds 23,0			;17 23
	out (C),E		;40 4 pen 3 to yellow

	;prepare for last sequence
	ld DE,#4B4C		;44 3 WHITE/RED	
	ld C,1			;47 2 work on pen 1 from now	
	ld HL,#5540		;49 3 blue/grey
	
	ds 61-52,0
	
	ret
	
.line_head_color1
	out (C),C		;0 	4 set to pen 1
	out (C),H		;4 	4 pen 1 to blue (we are on border now)
	ds 11,0			;8 	11
	out (C),D		;19 4 pen 1 to white
	out (C),H		;23 4 pen 1 to blue
	
	ds 61-27,0
	ret

.line_head_color2
	out (C),C		;0 	4 set to pen 1
	out (C),H		;4 	4 pen 1 to blue (we are on border now)
	ds 11,0			;8 	11
	out (C),D		;19 4 pen 1 to white
	out (C),E		;23 4 pen 1 to red
	out (C),H		;27 4 pen 1 to blue
	
	ds 61-31,0
	ret	
	
.line_head_color3
	out (C),C		;0 	4 set to pen 1
	out (C),H		;4 	4 pen 1 to blue (we are on border now)
	ds 15,0			;8 	15
	out (C),E		;23 4 pen 1 to red
	out (C),H		;27 4 pen 1 to blue
	
	ds 61-31,0
	ret	
	
.line_head_color4
	out (C),C		;0 	4 set to pen 1
	out (C),H		;4 	4 pen 1 to blue (we are on border now)
	ds 13,0			;8 	13
	out (C),D		;21 4 pen 1 to white
	out (C),E		;25 4 pen 1 to red
	out (C),H		;29 4 pen 1 to blue
	
	ds 61-33,0
	ret	
	
.line_head_color5
	out (C),C		;0 	4 set to pen 1
	out (C),H		;4 	4 pen 1 to blue (we are on border now)
	ds 13,0			;8 	13
	out (C),D		;21 4 pen 1 to white
	nop
	out (C),H		;25 4 pen 1 to blue
	
	ds 61-30,0
	ret
	
.line_head_color5_last
	out (C),C		;0 	4 set to pen 1
	out (C),H		;4 	4 pen 1 to blue (we are on border now)
	ds 13,0			;8 	13
	out (C),D		;21 4 pen 1 to white
	nop
	out (C),H		;26 4 pen 1 to blue
	
	ld A,2			;2
	out (C),A		;4 pen 2
	out (C),E		;4 red
	
	ds 61-40,0
	ret	
	
.line_head_color6
	out (C),C		;0 	4 set to pen 1
	out (C),H		;4 	4 pen 1 to blue (we are on border now)
	ds 14,0			;8 	14
	out (C),D		;22 4 pen 1 to white
	;out (C),L		;25 4 pen 1 to grey
	out (C),H		;26 4 pen 1 to blue
	
	ds 61-30,0
	ret	
	
.line_head_color7
	out (C),C		;0 	4 set to pen 1
	out (C),H		;4 	4 pen 1 to blue (we are on border now)
	ds 15,0			;8 	14
	out (C),D		;22 4 pen 1 to white
	;out (C),L		;25 4 pen 1 to grey
	out (C),H		;26 4 pen 1 to blue
	
	ds 61-31,0
	ret
	
.line_press_key_preline
	ld DE,#0253	;3 colors for "MAK"
	out (C),D	;4 prefetch pen 2
	ds 61-7,0
	ret
	
.line_press_key_color1
	ld A,#5C	;2 	= 2		txt color
	out (C),A	;4 	= 6
	ds 20,0		;20 = 26
	out (C),E	;4  = 30	mak logo
	ds 61-30
	ret
	
.line_press_key_color2
	ld A,#4C	;2 	= 2		txt color
	out (C),A	;4 	= 6
	ds 20,0		;20 = 26
	out (C),E	;4  = 30	mak logo
	ds 61-30
	ret
	
.line_press_key_color3
	ld A,#4E	;2 	= 2		txt color
	out (C),A	;4 	= 6
	ds 20,0		;20 = 26
	out (C),E	;4  = 30	mak logo
	ds 61-30
	ret	
	
.line_press_key_color4
	ld A,#43	;2 	= 2		txt color
	out (C),A	;4 	= 6
	ds 20,0		;20 = 26
	out (C),E	;4  = 30	mak logo
	ds 61-30
	ret	
	
.line_press_key_color5
	ld A,#4B	;2 	= 2		txt color
	out (C),A	;4 	= 6
	ds 20,0		;20 = 26
	out (C),E	;4  = 30	mak logo
	ds 61-30
	ret	
	
.line_press_key_color6
	ld A,#4F	;2 	= 2		txt color
	out (C),A	;4 	= 6
	ds 20,0		;20 = 26
	out (C),E	;4  = 30	mak logo
	ds 61-30
	ret	

.line_press_key_color7
	ld A,#48	;2 	= 2		txt color
	out (C),A	;4 	= 6
	ds 20,0		;20 = 26
	out (C),E	;4  = 30	mak logo
	ds 61-30
	ret	

.line_press_key_color8
	ld A,#58	;2 	= 2		txt color
	out (C),A	;4 	= 6
	ds 20,0		;20 = 26
	out (C),E	;4  = 30	mak logo
	ds 61-30
	ret		
	
.line_press_key_color9
	ld A,#44	;2 	= 2		txt color
	out (C),A	;4 	= 6
	ds 20,0		;20 = 26
	out (C),E	;4  = 30	mak logo
	ds 61-30
	ret	

.line_press_key_color10
	ld A,#55	;2 	= 2		txt color
	out (C),A	;4 	= 6
	ds 20,0		;20 = 26
	out (C),E	;4  = 30	mak logo
	ds 61-30
	ret			
	
.line_press_key_color11
	ld A,#57	;2 	= 2		txt color
	out (C),A	;4 	= 6
	ds 20,0		;20 = 26
	out (C),E	;4  = 30	mak logo
	ds 61-30
	ret	

.line_press_key_color12
	ld A,#56	;2 	= 2		txt color
	out (C),A	;4 	= 6
	ds 20,0		;20 = 26
	out (C),E	;4  = 30	mak logo
	ds 61-30
	ret	

.line_press_key_color13
	ld A,#52	;2 	= 2		txt color
	out (C),A	;4 	= 6
	ds 20,0		;20 = 26
	out (C),E	;4  = 30	mak logo
	ds 61-30
	ret	

.line_press_key_color14
	ld A,#4A	;2 	= 2		txt color
	out (C),A	;4 	= 6
	ds 20,0		;20 = 26
	out (C),E	;4  = 30	mak logo
	ds 61-30
	ret		
	
	
.line_last
	ld DE,#0253	;3
	out (C),D	;4	set pen 2
	out (C),E	;4	set pen 2 to color bright cyan
	;setup screen normal size
	ld BC,#BC01	;3
	ld A,#21	;2
	out (C),C
	inc B
	out (C),A
	ret
	
	
	
	